;--------------------------------------------------------------------
;ds1302 rtc routine
;memory used:	r6, r7
;--------------------------------------------------------------------

rstrtc		bit p3.2
iortc		bit p3.6
sclkrtc		bit p3.7

day		data 30h
date		data 31h
month		data 32h
year		data 33h
hour		data 34h
min		data 35h
sec		data 36h

wrsec		equ 10000000b
rdsec		equ 10000001b
wrmin		equ 10000010b
rdmin		equ 10000011b
wrhour		equ 10000100b
rdhour		equ 10000101b
wrdate		equ 10000110b
rddate		equ 10000111b
wrmonth		equ 10001000b
rdmonth		equ 10001001b
wrday		equ 10001010b
rdday		equ 10001011b
wryear		equ 10001100b
rdyear		equ 10001101b
wrtcr		equ 10010000b
tcr		equ 10101001b


bcd2hex:	push acc
		anl a,#0fh
		mov b,a
		pop acc
		push b
		swap a
		anl a,#0fh
		mov b,#10
		mul ab
		pop b
		add a,b
		ret

hex2bcd:	mov b,#10
		div ab
		anl a,#0fh
		swap a
		anl b,#0fh
		orl a,b
		ret

wrrtc:		setb rstrtc
		mov r6,#8
wrrtcloop1:	rrc a
		mov iortc,c
		setb sclkrtc
		clr sclkrtc
		djnz r6,wrrtcloop1
		mov a,r7
		mov r6,#8
wrrtcloop2:	rrc a
		mov iortc,c
		setb sclkrtc
		clr sclkrtc
		djnz r6,wrrtcloop2
		clr rstrtc
		ret

rdrtc:		setb rstrtc
		mov r6,#8
rdrtcloop1:	rrc a
		mov iortc,c
		setb sclkrtc
		clr sclkrtc
		djnz r6,rdrtcloop1
		mov r6,#8
		setb iortc
rdrtcloop2:	mov c,iortc
		rrc a
		setb sclkrtc
		clr sclkrtc
		djnz r6,rdrtcloop2
		clr rstrtc
		ret

enabletcr:	mov r7,#tcr
		mov a,#wrtcr
		call wrrtc
		ret

runrtc:		mov a,sec
		call hex2bcd
		anl a,#7fh
		mov r7,a
		mov a,#wrsec
		call wrrtc
		ret
haltrtc:	mov a,sec
		call hex2bcd
		orl a,#80h
		jmp runrtc+6

setrtc:		mov a,sec
		call hex2bcd
		anl a,#7fh
		mov r7,a
		mov a,#wrsec
		call wrrtc
		mov a,min
		call hex2bcd
		mov r7,a
		mov a,#wrmin
		call wrrtc
		mov a,hour
		call hex2bcd
		mov r7,a
		mov a,#wrhour
		call wrrtc
		mov a,day
		call hex2bcd
		mov r7,a
		mov a,#wrday
		call wrrtc
		mov a,date
		call hex2bcd
		mov r7,a
		mov a,#wrdate
		call wrrtc
		mov a,month
		call hex2bcd
		mov r7,a
		mov a,#wrmonth
		call wrrtc
		mov a,year
		call hex2bcd
		mov r7,a
		mov a,#wryear
		call wrrtc
		ret

getrtc:		mov a,#rdsec
		call rdrtc
		anl a,#01111111b
		call bcd2hex
		mov sec,a
		mov a,#rdmin
		call rdrtc
		anl a,#01111111b
		call bcd2hex
		mov min,a
		mov a,#rdhour
		call rdrtc
		anl a,#00111111b
		call bcd2hex
		mov hour,a
		mov a,#rdday
		call rdrtc
		anl a,#00000111b
		call bcd2hex
		mov day,a
		mov a,#rddate
		call rdrtc
		anl a,#00111111b
		call bcd2hex
		mov date,a
		mov a,#rdmonth
		call rdrtc
		anl a,#00011111b
		call bcd2hex
		mov month,a
		mov a,#rdyear
		call rdrtc
		anl a,#11111111b
		call bcd2hex
		mov year,a
		ret
